Index: kernel/generic/src/main/main.c
===================================================================
--- kernel/generic/src/main/main.c	(revision 1ba37faf61b6713df5140f30fa781f7f2147c5ab)
+++ kernel/generic/src/main/main.c	(revision 516adcede91f3e4a1e790d6a39694d4b25772eb9)
@@ -224,5 +224,5 @@
 	printf("Detected %" PRIs " CPU(s), %" PRIu64" MiB free memory\n",
 	    config.cpu_count, SIZE2MB(zone_total_size()));
-	
+
 	LOG_EXEC(cpu_init());
 	
Index: kernel/generic/src/mm/frame.c
===================================================================
--- kernel/generic/src/mm/frame.c	(revision 1ba37faf61b6713df5140f30fa781f7f2147c5ab)
+++ kernel/generic/src/mm/frame.c	(revision 516adcede91f3e4a1e790d6a39694d4b25772eb9)
@@ -1218,4 +1218,26 @@
 }
 
+void zone_busy_and_free(uint64_t *out_busy, uint64_t *out_free)
+{
+	ipl_t ipl = interrupts_disable();
+	spinlock_lock(&zones.lock);
+
+	uint64_t busy = 0, free = 0;
+	size_t i;
+	for (i = 0; i < zones.count; i++) {
+		bool available = zone_flags_available(zones.info[i].flags);
+		/* Do not count reserved memory */
+		if (available) {
+			busy += (uint64_t) FRAMES2SIZE(zones.info[i].busy_count);
+			free += (uint64_t) FRAMES2SIZE(zones.info[i].free_count);
+		}
+	}
+
+	spinlock_unlock(&zones.lock);
+	interrupts_restore(ipl);
+	*out_busy = busy;
+	*out_free = free;
+}
+
 /** Prints list of zones. */
 void zone_print_list(void)
Index: kernel/generic/src/ps/mem.c
===================================================================
--- kernel/generic/src/ps/mem.c	(revision 516adcede91f3e4a1e790d6a39694d4b25772eb9)
+++ kernel/generic/src/ps/mem.c	(revision 516adcede91f3e4a1e790d6a39694d4b25772eb9)
@@ -0,0 +1,59 @@
+/*
+ * Copyright (c) 2010 Stanislav Kozina
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup genericps
+ * @{
+ */
+
+/**
+ * @file
+ * @brief	Mem info
+ */
+
+#include <ps/meminfo.h>
+#include <ps/ps.h>
+#include <syscall/copy.h>
+#include <mm/frame.h>
+#include <arch.h>
+
+int sys_ps_get_mem_info(uspace_mem_info_t *uspace_mem)
+{
+	uspace_mem_info_t meminfo;
+	ipl_t ipl;
+	ipl = interrupts_disable();
+
+	meminfo.total = zone_total_size();
+	zone_busy_and_free(&meminfo.used, &meminfo.free);
+	interrupts_restore(ipl);
+
+	copy_to_uspace(uspace_mem, &meminfo, sizeof(uspace_mem_info_t));
+	return 0;
+}
+
+/** @}
+ */
Index: kernel/generic/src/syscall/syscall.c
===================================================================
--- kernel/generic/src/syscall/syscall.c	(revision 1ba37faf61b6713df5140f30fa781f7f2147c5ab)
+++ kernel/generic/src/syscall/syscall.c	(revision 516adcede91f3e4a1e790d6a39694d4b25772eb9)
@@ -171,4 +171,5 @@
 	/* Ps calls */
 	(syshandler_t) sys_ps_get_cpu_info,
+	(syshandler_t) sys_ps_get_mem_info,
 	(syshandler_t) sys_ps_get_tasks,
 	(syshandler_t) sys_ps_get_task_info,